UNIT Daten;

Interface
uses DOS, CRT;
var   Puffer : Array [1..6144] of Byte;

procedure Oeffnen9600;
procedure Senden  ( Wert : Byte );
function Empfang : Byte;
procedure SystemReset;
procedure Init4Kanal (Laenge, Zeit: Integer);
procedure Start;
procedure Einlesen (Anzahl : Integer);
function Spannung (Kanal : Integer): Real;
function Batteriespannung: Real;
procedure BusAus (Adresse, Datum : Byte);
function BusEin  (Adresse : Byte): Byte;
procedure PortAus (Datum: Byte);
function PortEin : Byte;

Implementation

procedure Oeffnen9600;
   var  Wert : Byte;
   begin
     Port [$3FB]:=128;
     Port [$3F8]:= 12;
     Port [$3F9]:=  0;
     Port [$3FB]:=  7;
     Port [$3FC]:=  3;
     Wert := Port [$3f8]
   end;

procedure Senden  ( Wert : Byte );
   begin
     repeat
     until Port [$3FD] and 32 = 32;
     Port [$3F8]:= (Wert);
   end;

function Empfang : Byte;
   begin
     repeat until (Keypressed or
     ((Port [$3FD] and 1) = 1));
     Empfang := Port [$3F8];
   end;

procedure SystemReset;
var n : Integer;
begin
  for n:=1 to 10 do begin
    Senden (0);
    delay (4);
  end;
end;

procedure Init4Kanal (Laenge, Zeit: Integer);
begin
  SystemReset;
  Senden (1); delay (4);
  Senden (hi(Laenge));
  Senden (lo(Laenge));
  Senden (1);
  Senden (2);
  Senden (3);
  Senden (4);
  Senden (hi(Zeit-4));
  Senden (lo(Zeit-4));
  delay (4);
end;

procedure Start;
begin
  Senden (9);
end;




procedure Einlesen (Anzahl : Integer);
var n, dummy : Integer;
begin
  SystemReset;
  Senden (2); delay (4);
  for n:= 1 to 8 do begin
     Senden (1);
     Dummy := Empfang;
  end;
  for n:= 1 to Anzahl do begin
     Senden (1);
     Puffer [n] := Empfang;
  end;
  Senden (0);
end;

function Spannung (Kanal : Integer): Real;
begin
  Senden (7);
  Senden (Kanal);
  Spannung := Empfang / 100;
end;

function Batteriespannung: Real;
begin
  Batteriespannung := Spannung (4) * (820+470) / 470;
end;

procedure BusAus (Adresse, Datum : Byte);
begin
  Senden (8);
  Senden (Adresse);
  Senden (Datum);
end;

function BusEin  (Adresse : Byte): Byte;
begin
  Senden (8);
  Senden (Adresse + 128);
  BusEin := Empfang;
end;

procedure PortAus (Datum: Byte);
begin
  Senden (11);
  Senden (Datum);
end;

function PortEin : Byte;
begin
  Senden (12);
  PortEin := Empfang;
end;

begin
end.
