program Frequenzmessung;
uses CRT, RS232;

var
  Frequenz  :    Real;

procedure Oeffnen8192;
   var  Wert : Byte;
   begin
     Port [$3FB]:=128;          { Baudeingabe aktivieren    }
     Port [$3F8]:= 14;          { Baudrate - LSB, 8200 Baud }
     Port [$3F9]:=  0;          { Baudrate - MSB            }
     Port [$3FB]:=  3;          { 8 Bits, No Parity, 1 Stop }
     Port [$3FC]:=  3;          { DTR = 1, RTS = 1          }
     Wert := Port [$3F8]        { Empfangsregister leeren   }
   end;

procedure Messen ( Anzahl: Integer; Var Frequenz : Real);
var
  High                     :    Real;
  Wert, Alt, Erst, Start   :    Byte;
  Nummer                   :    Integer;

begin;
   Oeffnen8192;
   High := 0;
   Wert := 0;
   delay (20);
   Empfangen (Wert);
   Empfangen (Wert);
   Empfangen (Wert);
   Alt:=Wert;
   Erst:=Wert;
   for Nummer:=1 to Anzahl
   do begin
     Empfangen (Wert);
     if Wert < Alt then High := High + 1;
     Alt := Wert;
   end;
   Frequenz := 256 * High + Wert - Erst;
   Frequenz := Frequenz / Anzahl * 819.2;
   Schliessen;
end;
.pa
{verbesserte Frequenzmessung}
procedure Messen2 ( Anzahl: Integer; Var Frequenz : Real);
var
  High                     :    Real;
  Wert, Alt, Erst, Start   :    Byte;
  Nummer, Diff             :    Integer;

begin;
   Oeffnen8192;
   High := 0;
   Wert := 0;
   delay (20);
   Empfangen (Start);
   Empfangen (Wert);
   if Wert > Start then Diff := Wert - Start;
   if Wert < Start then Diff := Wert - (Start + 256);
   Empfangen (Wert);
   Alt:=Wert;
   Erst:=Wert;
   for Nummer:=1 to Anzahl
   do begin
     Empfangen (Wert);
     if( abs (( Alt + Diff) and 255) - Wert ) > 15
     then Wert := (Alt + Diff) and 255;
     if Wert < Alt then High := High + 1;
     Alt := Wert;
   end;
   Frequenz := 256 * High + Wert - Erst;
   Frequenz := Frequenz / Anzahl * 819.2;
   Schliessen;
end;

begin;
   ClrScr;
   Textmode (0);
   write (' Messung abbrechen mit Ctr C ');
   repeat
     GotoXY (1,10);
     Messen (4096, Frequenz );
     write ('      ',Frequenz:7:1,' Hz  ');
   until KeyPressed
end.
