Program MAX132;
Uses CRT;
var BA : Integer;
    Offset: Real;

procedure Init;
begin
   BA := $03F8;
   Port[BA+3]:=$40; { Break, TXD(/CS)=1 }
   Port[BA+4]:=$00; { DTR(Sclk) = 0, RTS(Din) = 0 }
   delay (100);
end;

function shift8 (Commando: Byte):Byte;
var Aus, Lesen, Bit, N: Byte;
  i : Integer;
begin
  Port[BA+3]:=$00; { /CS:= 0 }
  Bit := 128;
  Lesen := 0;
  for n:=1 to 8 do begin
    if (Commando AND Bit) = Bit then Aus := 2 else Aus := 0;
    Port[BA+4]:=Aus; { Din }
    for i := 1 to 1 do;
    Port[BA+4]:=Aus+1; { Din + Sclk }
    for i := 1 to 20 do;
    if (Port[BA+6] AND 16)= 16 then Lesen := Lesen + Bit;
    Port[BA+4]:=Aus; { Din }
    for i := 1 to 1 do;
    Bit := Bit div 2;
  end;
  Shift8 := Lesen;
  Port[BA+3]:=$40; { /CS:= 1 }
  Port[BA+4]:=$00; { /CS:= 1 }
  delay(2);
end;

function Messung: Real;
var Dummy: Byte;
    Wert: Real;
begin
  Dummy := shift8(128+64+4);               {Start, 50Hz, R2}
  repeat until (Port[BA+6] AND 32)= 32;    {EOF}
  delay (1);
  Wert := 1024.0 * shift8(0);              {R0}
  Wert := Wert + 8.0 * shift8(2);          {R2}
  Wert := Wert + 1.000 * (Ausgabe AND 7);
  if ((Ausgabe AND 8) = 8) then          {Eingang negativ?}
     Wert := Wert - 262144 ;
  Messung := Wert*1.000-Offset;
end;

procedure Portausgabe (Wert:Byte);
var Dummy : Byte;
begin
  Dummy := shift8(Wert*16+1);    {Steuerregister 1}
end;


function Mittelung: Real;
var Summe: Real;
    n : Integer;
begin
  Summe := 0;
  for n:= 1 to 20 do Summe := Summe + Messung;
  Mittelung := Summe / 20;
end;


procedure Nullpunkt;
var Summe: Real;
    n : Integer;
    Dummy: Byte;
    Wert: Real;
begin
  Summe := 0;
  for n:= 1 to 20 do begin
     Dummy := shift8(128+64+16+4);          {Read Zero}
     repeat until (Port[BA+6] AND 32)= 32;
     delay (1);
     Wert := 1024.0 * shift8(0);
     Wert := Wert + 8.0 * shift8(2);
     Wert := Wert + 1.000 * (Ausgabe AND 7);
     if ((Ausgabe AND 8) = 8) then Wert := Wert - 262144 ;
     Summe := Summe + Wert;
  end;
  Offset := Summe / 20;
end;

begin
  Init;
  Nullpunkt;
  Nullpunkt;
  repeat writeln (Mittelung/512 :1:3, ' mV') until Keypressed;
end.

